SavedRequestInputFilter (Apache Tomcat 10.1.16 API Documentation)
Description: declaration: package: org.apache.coyote.http11.filters, class: SavedRequestInputFilter

Package org.apache.coyote.http11.filters

# Class SavedRequestInputFilter

java.lang.Object
org.apache.coyote.http11.filters.SavedRequestInputFilter

All Implemented Interfaces:
  `InputFilter`, `InputBuffer`

public class SavedRequestInputFilter extends Object implements InputFilter
Input filter responsible for replaying the request body when restoring the saved request after FORM authentication.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected ByteChunk`
  `input`
  The original request body.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SavedRequestInputFilter(ByteChunk input)`
  Create a new SavedRequestInputFilter.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Amount of bytes still available in a buffer.
  `int`
  `doRead(ApplicationBufferHandler handler)`
  Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler.
  `long`
  `end()`
  End the current request (has no effect).
  `ByteChunk`
  `getEncodingName()`
  Return the name of the associated encoding; here, the value is null.
  `boolean`
  `isFinished()`
  Has the request body been read fully?
  `void`
  `recycle()`
  Make the filter ready to process the next request.
  `void`
  `setBuffer(InputBuffer buffer)`
  Set the next buffer in the filter pipeline (has no effect).
  `void`
  `setRequest(Request request)`
  Set the content length on the request.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### input

    protected ByteChunk input
    The original request body.

- ## Constructor Details

  - ### SavedRequestInputFilter

    public SavedRequestInputFilter(ByteChunk input)
    Create a new SavedRequestInputFilter.
    Parameters:
      `input` - The saved request body to be replayed.

- ## Method Details

  - ### doRead

    public int doRead(ApplicationBufferHandler handler) throws IOException
    Description copied from interface: `InputBuffer`
    Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler. IMPORTANT: the current model assumes that the protocol will 'own' the ByteBuffer and return a pointer to it.
    Specified by:
      `doRead` in interface `InputBuffer`
    Parameters:
      `handler` - ApplicationBufferHandler that provides the buffer to read data into.
    Returns:
      The number of bytes that have been added to the buffer or -1 for end of stream
    Throws:
      `IOException` - If an I/O error occurs reading from the input stream

  - ### setRequest

    public void setRequest(Request request)
    Set the content length on the request.
    Specified by:
      `setRequest` in interface `InputFilter`
    Parameters:
      `request` - The request to be associated with this filter

  - ### recycle

    public void recycle()
    Make the filter ready to process the next request.
    Specified by:
      `recycle` in interface `InputFilter`

  - ### getEncodingName

    public ByteChunk getEncodingName()
    Return the name of the associated encoding; here, the value is null.
    Specified by:
      `getEncodingName` in interface `InputFilter`
    Returns:
      The encoding name as a byte chunk to facilitate comparison with the value read from the HTTP headers which will also be a ByteChunk

  - ### setBuffer

    public void setBuffer(InputBuffer buffer)
    Set the next buffer in the filter pipeline (has no effect).
    Specified by:
      `setBuffer` in interface `InputFilter`
    Parameters:
      `buffer` - The next buffer

  - ### available

    public int available()
    Amount of bytes still available in a buffer.
    Specified by:
      `available` in interface `InputBuffer`
    Returns:
      The number of bytes that can be read without blocking

  - ### end

    public long end() throws IOException
    End the current request (has no effect).
    Specified by:
      `end` in interface `InputFilter`
    Returns:
      0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
    Throws:
      `IOException` - If an error happens

  - ### isFinished

    public boolean isFinished()
    Description copied from interface: `InputFilter`
    Has the request body been read fully?
    Specified by:
      `isFinished` in interface `InputFilter`
    Returns:
      `true` if the request body has been fully read, otherwise `false`